#portions of this code are modifications of examples from Google
  # Copyright 2005-2007, Google, Inc.
  # V2.0
  
  require 'sketchup.rb'
  
  def create_board
   model=Sketchup.active_model
   #apparently no need to use.start_operation
   # and commit_operation

   # lets purge unused component definitions
   if Sketchup.version_number >6000276
    definitions=model.definitions
    definitions.purge_unused
   end#if	
   
 def inputform(deflts,choico)
  params=nil
  taxis=nil
  tlgth=nil
  twidt=nil
  tthik=nil
  tname=nil
  results=[]
  #deflts=["gr","10","3.5",".75","Herbie"]
  #choices=["choice1","choice2","Herbie"]
  
  wdlg=UI::WebDialog.new("Input Board",true,"",100,250,2000,1000,true)
   html1="
      <html>
	   <body>
	    <p>Lgth/Width Axis's---
		 <select id='axdrpdn'>
		 "
	htmlo1=	  "<option value='rg'>R/G</option>"
	if deflts[0]=="rg" then htmlo1=	  "<option value='rg' selected>R/G</option>" end
	htmlo2=	  "<option value='rb'>R/B</option>"
	if deflts[0]=="rb" then htmlo2=	  "<option value='rb' selected>R/B</option>" end
	htmlo3=	  "<option value='gr'>G/R</option>"
	if deflts[0]=="gr" then htmlo3=	  "<option value='gr' selected>G/R</option>" end
	htmlo4=	  "<option value='gb'>G/B</option>"
	if deflts[0]=="gb" then htmlo4=	  "<option value='gb' selected>G/B</option>" end
	htmlo5=	  "<option value='br'>B/R</option>"
	if deflts[0]=="br" then htmlo5=	  "<option value='br' selected>B/R</option>" end
	htmlo6=	  "<option value='bg'>B/G</option>"
	if deflts[0]=="bg" then htmlo6=	  "<option value='bg' selected>B/G</option>" end
	html1=html1+htmlo1+htmlo2+htmlo3+htmlo4+htmlo5+htmlo6
	html2="
		 </select>
		 </p>
		<p>Length----<input type='text' id='tlg' value="+deflts[1]+" size=15></p>
		<p>Width-----<input type='text' id='twd' value="+deflts[2]+" size=15></p>
		<p>Thickness-<input type='text' id='ttk' value="+deflts[3]+" size=15></p>
	    <p>Name----
	     <select id='drpdn1' onchange='change_drpdn1()'>
		 "
   #htmlc="<option value='opt1'>Option1</option>
   #		 <option value='opt2'>Option2</option>
   #		 <option value='opt3'>Option3</option>"
	htmlc=""
	j=0
	choico.each do |ctxt|
	 j=j+1
	 htmlc=htmlc+"<option value='opt"+j.to_s+"'>"+ctxt+"</option>"
	end
   html3="		 
		 </select>
		<input type='text' id='txopt' value="+deflts[4]+" size=25>
		 </p>
		 <input type='button' name='ok' value='    Ok   ' onclick='close_ok();' />&nbsp;&nbsp;&nbsp;
		 <input type='button' name='cancel' value='Cancel' onclick='close_cancel();' />
		 <hr>
		 <input type='button' name='store' value='Store Defaults' onclick='close_store();' />
		 <input type='button' name='load' value='Load Defaults ' onclick='close_load();' />
      <script type='text/javascript'>
	     function change_drpdn1() {
		   var x=document.getElementById('drpdn1');
		   var y=document.getElementById('txopt');
		   var stxt=x.options[x.selectedIndex].text;
		   y.value=stxt;
		   }
	     function close_ok() {
           window.location='skp:close_ok@Ok';
           }
		 function close_cancel() {
           window.location='skp:close_cancel@Cancel';
           }
		 function close_store() {
           window.location='skp:close_store@Store';
           }  
		 function close_load() {
           window.location='skp:close_load@Load';
           }   
	  </script>
	   </body>
	  </html>
	  "
	  wdlg.add_action_callback("close_ok") {
            |d,params|
			taxis=wdlg.get_element_value("axdrpdn").to_s
			tlgth=wdlg.get_element_value("tlg").to_s
			twidt=wdlg.get_element_value("twd").to_s
			tthik=wdlg.get_element_value("ttk").to_s
			tname=wdlg.get_element_value("txopt").to_s
            wdlg.close 
         }
	  wdlg.add_action_callback("close_cancel") {
            |d,params|
            wdlg.close 
         }
      wdlg.add_action_callback("close_store") {
            |d,params|
            wdlg.close 
         }
	  wdlg.add_action_callback("close_load") {
            |d,params|
            wdlg.close 
         }	 
  
  wdlg.set_html(html1+html2+htmlc+html3)
 
  wdlg.show_modal
  
  if params==nil
   params="Cancel"
  end
  #if params==nil 
  # UI.messagebox("Closed with box")
  results=[params,taxis,tthik,twidt,tlgth,tname]
  return results
 end
 
   def getdefaults    #input default values
    prompts = ["Length","Width", "Thickness","Name1","Name2","Name3","Name4","Name5"]
    defaults= [@val4,@val3,@val2,"--","--","--","--","--"]
	j=2
	@choices.each do |txt|
	 j=j+1
	 defaults[j]=txt
	end
   # choices = ["R/G|R/B|G/R|G/B|B/R|B/G","","","","",""]
   # results = inputbox prompts, defaults, choices, "Input Board2"
    desults=inputbox prompts,defaults,"Input Defaults"
    return desults
   end
   
   def assigndefaults(inprom)  #sets instance variables from array
     j=0
	 @choices=[]
	 inprom.each do |pit|
	  j=j+1
	  if j==1 then @val4=pit.strip end
	  if j==2 then @val3=pit.strip end
	  if j==3 then @val2=pit.strip end
	  if j>=4 and !(pit.strip=="--") 
  	   @choices<<pit.strip
	  end
     end	  
   end
   
   def storedictionary  #store model dictionary
    model=Sketchup.active_model
	prompts = ["Length","Width", "Thickness","Name1","Name2","Name3","Name4","Name5"]
	vals=[@val4,@val3,@val2,"--","--","--","--","--"]
	j=2
	@choices.each do |txt|
	 j=j+1
	 vals[j]=txt
	end
	0.upto(7) do |i|
	 v=model.set_attribute "woodwrkdict",prompts[i],vals[i]
	end
   end
   
   def readdictionary
    model=Sketchup.active_model
	prompts = ["Length","Width", "Thickness","Name1","Name2","Name3","Name4","Name5"]
	vals=[@val4,@val3,@val2,"--","--","--","--","--"]
	@choices=[]
	j=-1
	 prompts.each do |pit|
	  j=j+1
	  vt=model.get_attribute "woodwrkdict",pit,prompts[j]
	  if j==0 then @val4=vt.strip end
	  if j==1 then @val3=vt.strip end
	  if j==2 then @val2=vt.strip end
	  if j>=3 and !(vt.strip=="--") 
  	   @choices<<vt.strip
	  end
     end	
	
   end
   
   def evaluatestrto_l(fi) 
    new_l=0
	nf="haha"
	f=fi.delete(" ")
	a=f.split(/[-+*()\/]+/)
	b=f.split(/[^-+*()\/]+/)
	if b.length==0
	 new_l=f.to_l
	elsif b.length==1 && a[0]=="" && b[0]=="-" 
     new_l=f.to_l
    elsif b.length==1 && a[0]=="" && b[0]=="+" 
     nf=a[1]
	 new_l=a[1].to_l
    else
     if a[0]=="" then ac=1;bc=1;nf=b[0] end
	 if b[0]=="" then ac=0;bc=1;nf="" end
	 al=a.length-1
	 bl=b.length-1
	 until ac>al && bc>bl
	  if ac<=al 
	   z=a[ac].to_l.to_f.to_s
	   nf=nf+z 
	  end
	  if bc<=bl then nf=nf+b[bc] end
	  ac=ac+1
	  bc=bc+1
	 end
	 ze=eval nf
	 new_l=ze.to_l
	end
    return new_l
   end
   
   def insertcomponent(results)
    model=Sketchup.active_model
    @val1=results[1]
    @val2=results[2]
    @val3=results[3]
    @val4=results[4]
    @val5=results[5]
    v2=evaluatestrto_l(@val2)
	v3=evaluatestrto_l(@val3)
	v4=evaluatestrto_l(@val4)
    #Create component definition
    new_comp_def=model.definitions.add("Board")
    #create array
    points=Array.new

    if @val1=="rg"
     points[0]=[0, 0, 0]
     points[1]=[v4,0,0]
     points[2]=[v4,v3,0]
     points[3]=[0,v3,0]
     height=v2
    elsif @val1=="rb"
     points[0]=[0, 0, 0]
     points[1]=[v4,0,0]
     points[2]=[v4,v2,0]
     points[3]=[0,v2,0]
     height=v3
    elsif @val1=="gr"
     points[0]=[0, 0, 0]
     points[1]=[v3,0,0]
     points[2]=[v3,v4,0]
     points[3]=[0,v4,0]
     height=v2
    elsif @val1=="gb"
     points[0]=[0, 0, 0]
     points[1]=[v2,0,0]
     points[2]=[v2,v4,0]
     points[3]=[0,v4,0]
     height=v3
    elsif @val1=="br"
     points[0]=[0, 0, 0]
     points[1]=[v3,0,0]
     points[2]=[v3,v2,0]
     points[3]=[0,v2,0]
     height=v4
    else
     points[0]=[0, 0, 0]
     points[1]=[v2,0,0]
     points[2]=[v2,v3,0]
     points[3]=[0,v3,0]
     height=v4
    end


    #add the face to the component
    face=new_comp_def.entities.add_face(points)
    #if blue face is pointing up, reverse it
    face.reverse! if(face.normal.z<0)
   
    name=new_comp_def.name=@val5

    #pull up the height
    face.pushpull(height)
   
    #inserts component at left click in model
    status=model.place_component(new_comp_def)
   end   
   
   # use instance variables as defaults, they are remembered
   #  ! is not
   if !@modl   #first time
    @modl=model
   else
    if !(@modl==model)
	 @newi=nil
	 @modl=model
    end	
   end
   if !@newi              #first time around
    @newi=1
    @val1="rg"
	@val2=0.5.to_l.to_s
	@val3=3.5.to_l.to_s
	@val4=10.0.to_l.to_s
	@val5="Comp Name"
	@choices=[]           # component name changes
    @choices<<"CompName1"
    @choices<<"CompName2"
	wdict=model.attribute_dictionary "woodwrkdict",true
    if wdict.length==0
     storedictionary
	else
	 readdictionary
    end
   end
   #basic loop
   
   #get input
   lagain=1
   while lagain>0
    lagain=0
	deflts=[@val1,@val4,@val3,@val2,@val5]
    results = inputform(deflts,@choices)
    return if results[0]=="Cancel"  # user canceled
	
	if results[0]=="Load"         # load default file and sets current default
	 lagain=1
	 fname=UI.openpanel "Load defaults"
	 inprom=[]
     if !(fname==nil)
	  inprom=File.readlines(fname)
	  assigndefaults(inprom)
	  storedictionary
	 else
      return	 
	 end
	elsif results[0]=="Store"       # store default file and sets current default
	 lagain=1
	 desults = getdefaults
	 if !desults 
	  return
	 end 
	 assigndefaults(desults)
	 storedictionary
	 fname=UI.savepanel "Save defaults"
	 if !(fname==nil)
	  f=File.open(fname,"w")
	   desults.each do |pit|
	    f.write pit+"\n"
	   end
	  f.close
	 else
      return	 
	 end 
	else                  #typical input
	 #insert component
     insertcomponent(results)
	end
   end
   #end loop
   
 end
 
 if( not file_loaded?("Create_Board.rb"))
  UI.menu("Draw").add_item("Create Board"){create_board}
 end

 file_loaded("Create_Board.rb")