 #portions of this code are modifications of examples from Google
  # Copyright 2005-2007, Google, Inc.
  # V2.0

  #The following adds a series or rb's to the 'Draw' menu. These rb's are in the woodwrk2 folder 
  #which must be in then Plugins folder. Included in the woodwrk2 folder are word .doc files 
  #briefly describe the individual files
  
  #Simply comment out the require 'woodwrk2/......rb that you don't want
  
  require 'sketchup.rb'
  
   #add_separator_to_menu("Draw")   -- delete if you don't like it
  UI.menu("Draw").add_separator
  
  #creates a component at cursor location with input Length, Width, Thickness and Name with 
  #specified axis orientation. User can create their own defaults etc.
  require 'woodwrk2/Create_Board.rb'
  
  #Resizes existing rectilinear component.
  require 'woodwrk2/ResizeBoard.rb'
  
  #drills holes one face of component
  require 'woodwrk2/DrillBoard.rb'
  
  #Creates Dado or rabbet on the face of existing component
  require 'woodwrk2/DadoBoard.rb'
  
  #Mortise/Tenon tool written by ktkoh. Added here with his permission.
  require 'woodwrk2/MortiseTool.rb'
  
  
  
  #The following ruby which includes two tools would be added to the Tools menu
  
  #1) Set Comp or Group to front
  #   Simply snaps the selected component or group to the red/blue plane
  #2) Set Comp Relative
  #   Two click method of moving a component relative to another. This is handy
  #   to set into place a component that you have brought in. An improvement on the
  #   Move command.
  require 'woodwrk2/setcomponents.rb'
  
  
  